/*
Copyright 2019-2020 vChain, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

	http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package api

import (
	"testing"

	"github.com/stretchr/testify/assert"
)

var (
	emptyLeaf = [32]uint8{0xa, 0x88, 0x11, 0x18, 0x52, 0x9, 0x5c, 0xae, 0x4, 0x53, 0x40, 0xea, 0x1f, 0xb, 0x27, 0x99, 0x44, 0xb2, 0xa7, 0x56, 0xa2, 0x13, 0xd9, 0xb5, 0x1, 0x7, 0xd7, 0x48, 0x97, 0x71, 0xe1, 0x59}
	// index=1, key=key, value=value
	testLeaf = [32]uint8{0x62, 0x2e, 0x82, 0xa6, 0x42, 0x48, 0x2c, 0x58, 0x96, 0x92, 0x3, 0xba, 0xda, 0x74, 0x40, 0x97, 0xc9, 0xdf, 0xff, 0x2f, 0xf3, 0x14, 0x36, 0xc7, 0xd9, 0x57, 0x21, 0x73, 0x7c, 0x5e, 0xed, 0xa9}
)

func TestDigest(t *testing.T) {
	assert.Equal(t, emptyLeaf, Digest(0, []byte{}, []byte{}))
	assert.Equal(t, testLeaf, Digest(1, []byte(`key`), []byte(`value`)))
}
